unit uTest;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, TransBtn;
type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    ScrollBar1: TScrollBar;
    ScrollBar2: TScrollBar;
    Button2: TButton;
    Image2: TImage;
    ScrollBar3: TScrollBar;
    ScrollBar4: TScrollBar;
    ScrollBar5: TScrollBar;
   
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure ScrollBar5Change(Sender: TObject);

  Protected

  private
    m_clrBtn :TTransBtn;
    m_TGTWnd :HWND;
    m_RotCntPt :TPoint;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
procedure TForm1.FormCreate(Sender: TObject);

begin
  m_TGTWnd := Self.Handle;
  m_clrBtn := nil;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Filename :string;
  btn : TButton;
begin
  m_RotCntPt :=Point(Self.Width div 2, Self.Height div 2);
  Filename := GetCurrentDir()+'\fish.bmp';
  btn := TButton(Sender);
  if not Boolean(btn.Tag) then
  begin
    m_clrBtn := TTransBtn.Create(Self);
    m_clrBtn.RgnBmp :=Image1.Picture.Bitmap;
  //  m_clrBtn.LoadRgnPicture(Filename);
    m_clrBtn.RgnMaskColor :=clRed;
    m_clrBtn.Parent := Self;
    m_clrBtn.RgnCntPos :=m_RotCntPt;
  end
  else begin
    m_clrBtn.Free;
    m_clrBtn :=nil;
  end;
  btn.Tag := not btn.Tag;
end;
procedure TForm1.FormDestroy(Sender: TObject);
begin
  m_clrBtn.Free;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var
  Pt :TPoint;
begin
  if m_clrBtn <> nil then
  begin
    pt :=Point(m_RotCntPt.X+ScrollBar1.Position, m_RotCntPt.Y+ScrollBar2.Position);
    m_clrBtn.RgnCntPos :=pt;
  end else begin
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  btn : TButton;
begin
  btn := TButton(Sender);
  if m_clrBtn <> nil then
  begin
    if not Boolean(btn.Tag) then
    begin
      m_clrBtn.RgnMaskColor :=clBlack;
      m_clrBtn.RgnBmp := Image2.Picture.Bitmap;
    end else begin
      m_clrBtn.RgnMaskColor :=clRed;
      m_clrBtn.RgnBmp := Image1.Picture.Bitmap;
    end;
    btn.Tag := not btn.Tag;
  end;
end;

procedure TForm1.ScrollBar3Change(Sender: TObject);
begin
  if m_clrBtn <> nil then
  begin
    m_clrBtn.RgnSclX :=ScrollBar3.Position/100;
    m_clrBtn.RgnSclY :=ScrollBar4.Position/100;
  end else begin
  end;
end;

procedure TForm1.ScrollBar5Change(Sender: TObject);
begin
  if m_clrBtn <> nil then
  begin
    m_clrBtn.RgnDeg :=ScrollBar5.Position;
  end else begin
  end;
end;
end.
